#!/usr/bin/python
#
# Progress bar for Update Agent
# Copyright (c) 1999, 2000 Red Hat, Inc.
#
# Author: Preston Brown <pbrown@redhat.com>

import gtk
import libglade
from GTK import TRUE, FALSE
from GDK import WATCH
class Progress:
    
    def __init__(self):
        self.xml = libglade.GladeXML("/usr/share/rhn/register/progress.glade", "progressWindow")
        self.progressWindow = self.xml.get_widget("progressWindow")
        self.progressWindow.connect("delete-event", self.progressWindow.hide)
        self.progressWindow.connect("hide", self.progressWindow.hide)
        cursor = gtk.cursor_new (WATCH)
        self.progressWindow.get_window().set_cursor(cursor)
        while gtk.events_pending():
            gtk.mainiteration(FALSE)


    def hide(self):
        self.progressWindow.hide()
        while gtk.events_pending():
            gtk.mainiteration(FALSE)
            
        del self

    def setLabel(self, text):
        label = self.xml.get_widget("progressLabel")
        label.set_text(text)
        while gtk.events_pending():
            gtk.mainiteration(FALSE)
        
    def setProgress(self, amount, total):
        if total != 0:
            i = (amount + 1.0) / total
            if i > 1:
                i = 1.0
            elif i < 0:
                i = 0
        else:
            i = 0

        self.xml.get_widget("progressBar").update(i)
        while gtk.events_pending():
            gtk.mainiteration(FALSE)


        
